#include "is-prime.h"

/*
 * receives n, an int64_t number
 * checks whether n is a prime number
 */
bool is_prime(int64_t n)
{
   /*
    * explicitly handle multiples of two and three
    */
   if((n%2 == 0) || (n%3 == 0)) return false;
   
   /*
    * now we only need to check divisibility by 6k-1 and 6k+1, gaining us a factor 3 speedup
    */
   for(int64_t i = 5; n >= i*i; i += 6)
      if((n % i == 0) || (n % (i+2) == 0))
         return false;

   // it's a prime number
   return true;
}

